/*****************************************************************************
* CN[ht@C
*****************************************************************************/
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include"Object.h"
#include"Shot.h"
#include"Player.h"
#include"Character.h"
#include"Boss.h"
#include"SampleBoss.h"
#include"SampleBossEx.h"
#include"Common.h"
/*****************************************************************************
* 萔}N
*****************************************************************************/
/*****************************************************************************
* 񋓒萔
*****************************************************************************/
/*****************************************************************************
* }N
*****************************************************************************/
/*****************************************************************************
* \̂̐錾
*****************************************************************************/
/*****************************************************************************
* f[^^̐錾
*****************************************************************************/
/*****************************************************************************
* ϐ錾
*****************************************************************************/
/*****************************************************************************
* ֐錾
*****************************************************************************/
/*****************************************************************************
* ϐ`
*****************************************************************************/
/*****************************************************************************
* ֐`
*****************************************************************************/
#pragma region ubN{bNX
//̊蓖ĂƏݒ
BossPtr DLL_Create(int* gh, int* shot_gh)
{
	//̊蓖
	BossPtr bp = (BossPtr)malloc(sizeof(Boss));

	//Oŏ
	memset(bp, 0, sizeof(Character));

	//l
	CHR_SET_SHOT(bp, SHT_Create(SHOT_WIDTH, SHOT_HEIGHT, SHOT_BOUNDS_WIDTH, SHOT_BOUNDS_HEIGHT,shot_gh, MAX_SHOT));
	CHR_SET_SHOTS(bp, MAX_SHOT);
	OBJ_SET_DRAW_FLAG(bp, 1);
	OBJ_SET_WIDTH(bp, WIDTH);
	OBJ_SET_HEIGHT(bp, HEIGHT);
	OBJ_SET_BOUNDS_WIDTH(bp, BOUNDS_WIDTH);
	OBJ_SET_BOUNDS_HEIGHT(bp, BOUNDS_HEIGHT);
	OBJ_SET_GRAPHIC_HANDLE(bp, gh);
	OBJ_SET_X(bp, (LIMIT_X + BASE_Y) / 2);
	OBJ_SET_Y(bp, (LIMIT_Y + BASE_Y) / 2);

	//Ԃ
	return bp;
}
//̉
void DLL_Destroy(BossPtr bp)
{
	//shot̉
	SHT_Destroy(CHR_GET_SHOT(bp));

	//bp̉
	free(bp);
}
//\[XpXԂ
char* DLL_GetGraphicPath()
{
	return BOSS_GRAPHIC_PATH;
}
char* DLL_GetShotGraphicPath()
{
	return SHOT_GRAPHIC_PATH;
}
#pragma endregion
static void ShotPattern01(BossPtr bp, PlayerPtr pp)
{
	static int n = 0;
	static int dx = 0, dy = 0;
	static int wait = 0;
	int i;
	if (n == 0) {
		double angle = atan2(
			(double)OBJ_GET_CENTER_Y(pp) - (double)OBJ_GET_CENTER_Y(bp), 
			(double)OBJ_GET_CENTER_X(pp) - (double)OBJ_GET_CENTER_X(bp)
			);
		dx = (int)(cos(angle) * SHOT_SPEED); 
		dy = (int)(sin(angle) * SHOT_SPEED);
	}
	if (wait <= 0) {
		for (i = 0; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], dx);
				SHT_SetDeltaY(&BOSS_SHOT[i], dy);

				wait = BOSS_WAIT;

				break;
			}
		}
	}
	for (i = 0; i < BOSS_SHOTS; i++) {	
		if (OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
			OBJ_MOVE(&BOSS_SHOT[i], SHT_GetDeltaX(&BOSS_SHOT[i]), SHT_GetDeltaY(&BOSS_SHOT[i]));
			if (OBJ_IS_ALL_OUT(&BOSS_SHOT[i], BASE_X, BASE_Y, LIMIT_X, LIMIT_Y)) {
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 0);
			}
		}
	}
	wait--;
}
static void ShotPattern02(BossPtr bp, PlayerPtr pp)
{
		static double n = 0;
	static int wait = 0;
	static double dn = 0;
	int i;
	double angle =  n * PI / 180.0;
	double angle2 = (n + 90.0) * PI / 180.0;
	double angle3 = (n + 180.0) * PI / 180.0;
	double angle4 = (n + 270.0) * PI / 180.0;

	if (wait <= 0) {
		for (i = 0; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle)));
				break;
			}
		}
		for (i = 0; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle2)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle2)));

				break;
			}
		}
		for (i = 0; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle3)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle3)));

				break;
			}
		}

		for (i = 0; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle4)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle4)));

				break;
			}
		}

		wait = BOSS_WAIT;

		dn = 1.0;
		//dn += 0.1;

		n += dn;
	}

	for (i = 0; i < BOSS_SHOTS; i++) {	
		if (OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
			OBJ_MOVE(&BOSS_SHOT[i], SHT_GetDeltaX(&BOSS_SHOT[i]), SHT_GetDeltaY(&BOSS_SHOT[i]));
			if (OBJ_IS_ALL_OUT(&BOSS_SHOT[i], BASE_X, BASE_Y, LIMIT_X, LIMIT_Y)) {
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 0);
			}
		}
	}


	wait--;
}
static void ShotPattern03(BossPtr bp, PlayerPtr pp)
{
	static double n = 0;
	static int wait = 0;
	static double dn = 0;
	int i;
	double angle =  n * PI / 180.0;
	double angle2 = (n + 90.0) * PI / 180.0;
	double angle3 = (n + 180.0) * PI / 180.0;
	double angle4 = (n + 270.0) * PI / 180.0;

	if (wait <= 0) {
		for (i = 0; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle)));
				break;
			}
		}
		for (; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle2)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle2)));

				break;
			}
		}
		for (; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle3)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle3)));

				break;
			}
		}

		for (; i < BOSS_SHOTS; i++) {
			if (!OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
				OBJ_SET_X(&BOSS_SHOT[i], OBJ_GET_CENTER_X(bp) - (OBJ_GET_WIDTH(&BOSS_SHOT[i]) / 2));
				OBJ_SET_Y(&BOSS_SHOT[i], OBJ_GET_CENTER_Y(bp) - (OBJ_GET_HEIGHT(&BOSS_SHOT[i]) / 2));
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 1);
				SHT_SetDeltaX(&BOSS_SHOT[i], (int)(SHOT_SPEED * cos(angle4)));
				SHT_SetDeltaY(&BOSS_SHOT[i], (int)(SHOT_SPEED * sin(angle4)));

				break;
			}
		}

		wait = BOSS_WAIT;

		dn += 0.1;

		n += dn;
	}

	for (i = 0; i < BOSS_SHOTS; i++) {	
		if (OBJ_GET_DRAW_FLAG(&BOSS_SHOT[i])) {
			OBJ_MOVE(&BOSS_SHOT[i], SHT_GetDeltaX(&BOSS_SHOT[i]), SHT_GetDeltaY(&BOSS_SHOT[i]));
			if (OBJ_IS_ALL_OUT(&BOSS_SHOT[i], BASE_X, BASE_Y, LIMIT_X, LIMIT_Y)) {
				OBJ_SET_DRAW_FLAG(&BOSS_SHOT[i], 0);
			}
		}
	}


	wait--;
}
static void MovePattern01(BossPtr bp, PlayerPtr pp)
{
	int dx = 0, dy = 0;
	int bx = OBJ_GET_X(bp);
	int by = OBJ_GET_Y(bp);
	int px = OBJ_GET_X(pp);
	int py = OBJ_GET_Y(pp);

	if (bx != px) {
		dx = (bx < px)? MOVE_SPEED : -MOVE_SPEED;
	}

	if (by != py) {
		dy = (by < py)? MOVE_SPEED : -MOVE_SPEED;
	}
	OBJ_MOVE(bp, dx, dy);
}
static void MovePattern02(BossPtr bp, PlayerPtr pp)
{
	static double counter = 0.0;
	double angle = counter * PI / 180.0;

	OBJ_SET_X(bp, (LIMIT_X + BASE_X) / 2 + (int)(100000 * cos(angle)) - OBJ_GET_WIDTH(bp) / 2);
	OBJ_SET_Y(bp, (LIMIT_Y + BASE_Y) / 2 + (int)(100000 * sin(angle)) - OBJ_GET_HEIGHT(bp) / 2);
	counter += 1;
}
//{X̓
void DLL_Update(BossPtr bp, PlayerPtr pp)
{
	//MovePattern0(bp, pp);
}
void DLL_UpdateShot(BossPtr bp, PlayerPtr pp)
{

	ShotPattern03(bp, pp);
}